Index: /extensions/event_cats/admin/autolog_entries.inc.php
===================================================================
--- /extensions/event_cats/admin/autolog_entries.inc.php	(revision 4328)
+++ /extensions/event_cats/admin/autolog_entries.inc.php	(revision 4329)
@@ -38,17 +38,5 @@
 if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
 
-global $template, $conf, $page,
- $ec_lists,   // array of following arrays :
-              //   $ec_lists['ec_table'] :
-              //     Event Cats table, in function of each entry id
-              //   $ec_lists['ec_codes'] : // Used ?
-              //     array of useful data, in function of entries codes
-              //   $ec_lists['add_pages'] :
-              //     array of Add. Pages names in function of their id
-              //   $ec_lists['categories'] :
-              //     array of category names in function of their id
-              //   $ec_lists['user_ids'] :
-              //     array of usernames in function of their id
- $ec_ap_ok;   // whether Additional Pages is installed and activated
+global $template, $conf, $page, $ec_lists;
 
 /****************************************************************************/
@@ -94,16 +82,12 @@
       switch ($a) {
         case 0: // Home
-          $dspl = l10n('ec_dspl_ok_home');
+          $dspl = l10n('Home');
         break;
         case 1: // Category
         case 3: // Image
           $url_end = ($ec_entry['forced'] == 'true') ? '' : '&amp;cat='.$arg1;
-          $dspl =
-           l10n('ec_dspl_ok_cat_pre').
-           $arg1.
-           l10n('ec_dspl_ok_cat_mid').
-           $ec_lists['categories'][$arg1_int].
-           l10n('ec_dspl_ok_cat_end')
-          ;
+          $dspl = sprintf(
+            l10n('ec_dspl_ok_cat'), $arg1, $ec_lists['categories'][$arg1_int]
+          );
           if (is_in($ec_entry['action'], '_img_pb')) {
             $url_end.= ($url_end == '') ? '' : '&amp;img='.$arg2;
@@ -112,9 +96,5 @@
             $dspl.=
              '<br>'.$span_err_pre.
-             l10n('ec_dspl_nok_img2_pre').
-             $arg2.
-             l10n('ec_dspl_nok_img2_mid').
-             $arg1.
-             l10n('ec_dspl_nok_img2_end').
+             sprintf(l10n('ec_dspl_nok_img2'), $arg2, $arg1).
              $span_err_end
             ;
@@ -122,32 +102,19 @@
           elseif ($a == 3) { // Image
             $url_end.= ($url_end == '') ? '' : '&amp;img='.$arg2;
-            $t = mysql_fetch_row(pwg_query('
+            $t = mysql_fetch_row(pwg_query("
              SELECT `name`, `file`
-             FROM `'.IMAGES_TABLE.'`
-             WHERE `id` = "'.$arg2.'"
-            '));
-            $dspl.=
-             '<br>'.
-             l10n('ec_dspl_ok_img2_pre').
-             $arg2.
-             l10n('ec_dspl_ok_img2_mid1').
-             $t[0].
-             l10n('ec_dspl_ok_img2_mid2').
-             $t[1].
-             l10n('ec_dspl_ok_img2_end')
-            ;
+             FROM `".IMAGES_TABLE."`
+             WHERE `id` = $arg2
+            "));
+            $dspl.= '<br>'.
+             sprintf(l10n('ec_dspl_ok_img2'), $arg2, $t[0], $t[1]);
           }
         break;
         case 2: // Additional Page
           $url_end = ($ec_entry['forced'] == 'true') ? '' : '&amp;ap='.$arg2;
-          $dspl = ($ec_ap_ok) ?
-           l10n('ec_dspl_ok_ap_pre').
-           $arg2.
-           l10n('ec_dspl_ok_ap_mid').
-           $ec_lists['add_pages'][$arg2_int].
-           l10n('ec_dspl_ok_ap_end')
-          :
-           l10n('ec_dspl_ok_home')
-          ;
+          $dspl = (EC_AP_OK) ? sprintf(
+            l10n('ec_dspl_ok_ap'),
+            $arg2, $ec_lists['add_pages'][$arg2_int]
+          ) : l10n('Home');
         break;
       }
@@ -156,16 +123,11 @@
     case 'ec_nok' :
       if (empty($ec_entry['arg2'])) {
-        $dspl = l10n('ec_dspl_nok_acc_denied');
+        $dspl = l10n('Access denied');
       }
       else {
-        $dspl = ($ec_ap_ok) ?
-         l10n('ec_dspl_ok_ap_pre').
-         $arg2.
-         l10n('ec_dspl_ok_ap_mid').
-         $ec_lists['add_pages'][$arg2_int].
-         l10n('ec_dspl_ok_ap_end')
-        :
-         l10n('ec_dspl_nok_acc_denied')
-        ;
+        $dspl = (EC_AP_OK) ? sprintf(
+            l10n('ec_dspl_ok_ap'),
+            $arg2, $ec_lists['add_pages'][$arg2_int]
+          ) : l10n('Access denied');
       }
     break;
@@ -177,14 +139,12 @@
       if (is_in($ec_entry['action'], 'ec_ok')) {
         $url_end = ($ec_entry['forced'] == 'true') ? '' : '&amp;ap='.$arg2;
-        $dspl = l10n('ec_dspl_ok_home');
+        $dspl = l10n('Home');
       }
       else {
-        $dspl = l10n('ec_dspl_nok_acc_denied');
+        $dspl = l10n('Access denied');
       }
       $dspl.=
        $span_err_pre.
-       l10n('ec_dspl_nok_ap_pre').
-       $arg2.
-       l10n('ec_dspl_nok_ap_end').
+       sprintf(l10n('ec_dspl_nok_ap'), $arg2).
        $span_err_end
       ;
@@ -196,9 +156,7 @@
        $ec_entry['code'].' : '.l10n('ec_category_miss');
       $dspl =
-       l10n('ec_dspl_nok_home').
-       $span_err_pre.
-       l10n('ec_dspl_nok_img1_pre').
-       $arg1.
-       l10n('ec_dspl_nok_img1_end').
+       l10n('Home').
+       $span_err_pre.
+       sprintf(l10n('ec_dspl_nok_cat'), $arg1).
        $span_err_end
       ;
@@ -213,5 +171,5 @@
        $span_err_end
       ;
-      $dspl = l10n('ec_dspl_ok_home');
+      $dspl = l10n('Home');
     break;
     
@@ -224,5 +182,5 @@
        $span_err_end
       ;
-      $dspl = l10n('ec_dspl_ok_home');
+      $dspl = l10n('Home');
     break;
     
@@ -232,10 +190,8 @@
       $username =
        $span_err_pre.
-       l10n('ec_dspl_nok_usr_pre').
-       $ec_entry['user_id'].
-       l10n('ec_dspl_nok_usr_end').
-       $span_err_end
-      ;
-      $dspl = l10n('ec_dspl_ok_home');
+       sprintf(l10n('ec_dspl_nok_usr'), $ec_entry['user_id']).
+       $span_err_end
+      ;
+      $dspl = l10n('Home');
     break;
   }
@@ -264,6 +220,7 @@
 }
 
-$template->assign('ec_ap_ok',$ec_ap_ok);
-$template->assign('code_list',$code_list);
+$template->assign('ec_ap_ok',  EC_AP_OK);
+$template->assign('ec_ap_ok2', (count($ec_lists['add_pages']) > 0));
+$template->assign('code_list', $code_list);
 
 ?>
Index: /extensions/event_cats/admin/autolog_new.inc.php
===================================================================
--- /extensions/event_cats/admin/autolog_new.inc.php	(revision 4328)
+++ /extensions/event_cats/admin/autolog_new.inc.php	(revision 4329)
@@ -38,17 +38,5 @@
 if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
 
-global $template, $conf, $page,
- $ec_lists,   // array of following arrays :
-              //   $ec_lists['ec_table'] :
-              //     Event Cats table, in function of each entry id
-              //   $ec_lists['ec_codes'] : // Used ?
-              //     array of useful data, in function of entries codes
-              //   $ec_lists['add_pages'] :
-              //     array of Add. Pages names in function of their id
-              //   $ec_lists['categories'] :
-              //     array of category names in function of their id
-              //   $ec_lists['user_ids'] :
-              //     array of usernames in function of their id
- $ec_ap_ok;   // whether Additional Pages is installed and activated
+global $template, $conf, $page, $ec_lists, $ec_conf_possible_values;
 
 /****************************************************************************/
@@ -79,12 +67,15 @@
       case 'create':
         $ec_default_action = $_POST['ec_act1'];
-        $ec_default_entry = $_POST['ec_entry_sel'];
+        $ec_default_entry =  $_POST['ec_entry_sel'];
       break;
       default:
-        $page['errors'][] = 'Demande inconnue : $_POST[\'ec_act1\'] = '.$_POST['ec_act1'];
+        $page['errors'][] =
+         'Bad argument : $_POST[\'ec_act1\'] = '.$_POST['ec_act1'];
     }
   }
   else
-   $page['errors'][] = 'Tentative d\'utilisation d\'une entrée inexistante ($_POST[\'ec_entry_sel\'] = '.$_POST['ec_entry_sel'].')';
+   $page['errors'][] =
+    'Entry doesn\'t exist ($_POST[\'ec_entry_sel\'] = '.
+    $_POST['ec_entry_sel'].')';
 }
 
@@ -97,8 +88,8 @@
   (count($ec_lists['user_ids']) == 0) ? 'style = "display:none;"' : ''
 );
-$template->assign('ec_no_assoc', ((mysql_num_rows(pwg_query('
+$template->assign('ec_no_assoc', ((mysql_num_rows(pwg_query("
   SELECT *
-  FROM `'.IMAGE_CATEGORY_TABLE.'`
-'))) == 0));
+  FROM `".IMAGE_CATEGORY_TABLE."`
+"))) == 0));
 $template->assign('ec_is_creation', (
     $ec_default_action == 'duplicate_entry_submit' or
@@ -108,9 +99,11 @@
   )
 );
-$template->assign('ec_ap_ok',               $ec_ap_ok);
+$template->assign('ec_ap_ok',               EC_AP_OK);
 $template->assign('ec_lists',               $ec_lists);
 $template->assign('ec_default_entry',       $ec_default_entry);
 $template->assign('ec_default_action',      $ec_default_action);
 $template->assign('ec_def_auto_code_dg_nb', $ec_def_auto_code_dg_nb);
+$template->assign('ec_auto_code_dg_nb',
+ $ec_conf_possible_values['auto_code_dg_nb']);
 
 ?>
Index: /extensions/event_cats/admin/config.inc.php
===================================================================
--- /extensions/event_cats/admin/config.inc.php	(revision 4328)
+++ /extensions/event_cats/admin/config.inc.php	(revision 4329)
@@ -1,3 +1,72 @@
 <?php
+// +-----------------------------------------------------------------------+
+// | Plugin Name : Event Cats                                              |
+// | Plugin Version : 1.0                                                  |
+// | File Version : 1.0                                                    |
+// | Plugin Version author : LucMorizur                                    |
+// | Plugin description : (plugin for Piwigo, http://piwigo.org )          |
+// | This plugin allows an account to be automatically logged in ; and to  |
+// | let users duplicate the account they are logged with, to get benefits |
+// | of the groups of the previous account, immediately on their new acc.  |
+// | Ce plugin permet d'identifier automatiquement un compte ; et permet à |
+// | un utilisateur de dupliquer un compte, pour que le nouveau compte     |
+// | bénéficie immédiatement de l'affectation aux groupes de l'ancien cpte |
+// +-----------------------------------------------------------------------+
+
+// +-----------------------------------------------------------------------+
+// | Piwigo - a PHP based picture gallery                                  |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2008-2009 Piwigo Team                  http://piwigo.org |
+// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
+// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
+
+global $ec_conf_default, $ec_conf;
+
+// +-----------------------------------------------------------------------+
+// | Global configuration management                                       |
+// +-----------------------------------------------------------------------+
+
+// Gets $lang['Register'] and $lang['Duplicate']
+load_language('common.lang');
+load_language('duplic.lang', EVNTCATS_PATH);
+
+$template->assign(
+  'ec_dup_link_conf',
+  sprintf(
+    l10n('Register replacement'),
+    '&nbsp;&nbsp;<br />', // nicer line feed
+    $lang['Register'],
+    $lang['Duplicate']
+  )
+);
+
+// In case some $lang have the same index, overwrites them to have the ones
+// needed here
+load_language('plugin.lang', EVNTCATS_PATH);
+
+$template->assign('ec_ap_ok', EC_AP_OK);
+$template->assign('add_pages', $ec_lists['add_pages']);
+
+// Sends configuration values to the template, described per key
+$ec_conf2 = array(); $i = 0;
+foreach ($ec_conf_default as $k => $v) { $ec_conf2[$k] = $ec_conf[$i]; $i++; }
+$template->assign('ec_conf', $ec_conf2);
 
 ?>
Index: /extensions/event_cats/admin/duplication.inc.php
===================================================================
--- /extensions/event_cats/admin/duplication.inc.php	(revision 4328)
+++ /extensions/event_cats/admin/duplication.inc.php	(revision 4329)
@@ -1,30 +1,73 @@
 <?php
+// +-----------------------------------------------------------------------+
+// | Plugin Name : Event Cats                                              |
+// | Plugin Version : 1.0                                                  |
+// | File Version : 1.0                                                    |
+// | Plugin Version author : LucMorizur                                    |
+// | Plugin description : (plugin for Piwigo, http://piwigo.org )          |
+// | This plugin allows an account to be automatically logged in ; and to  |
+// | let users duplicate the account they are logged with, to get benefits |
+// | of the groups of the previous account, immediately on their new acc.  |
+// | Ce plugin permet d'identifier automatiquement un compte ; et permet à |
+// | un utilisateur de dupliquer un compte, pour que le nouveau compte     |
+// | bénéficie immédiatement de l'affectation aux groupes de l'ancien cpte |
+// +-----------------------------------------------------------------------+
 
+// +-----------------------------------------------------------------------+
+// | Piwigo - a PHP based picture gallery                                  |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2008-2009 Piwigo Team                  http://piwigo.org |
+// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
+// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
 
+if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
 
+global $ec_conf_default;
 
+// +-----------------------------------------------------------------------+
+// | Duplication granted per groups/types/users management                 |
+// +-----------------------------------------------------------------------+
 
-
-/* */
-
-
-
-
-
-
-
-
+// In evntcats_main_funcs.inc.php ; determines all granted groups/types/users
+// Thanks to "true" parameter, assigns to the template all needed variables
 build_dup_arrays(true);
 
+// Gets $lang['Register'] and $lang['Duplicate']
+load_language('common.lang');
+load_language('duplic.lang', EVNTCATS_PATH);
 
+$template->assign(
+  'ec_dup_link_conf',
+  sprintf(
+    l10n('Register replacement'),
+    '&nbsp;&nbsp;<br />', // nicer line feed
+    $lang['Register'],
+    $lang['Duplicate']
+  )
+);
 
+// In case some $lang have the same index, overwrites them to have the ones
+// needed here
+load_language('plugin.lang', EVNTCATS_PATH);
 
-
-
-
-
-
-
-
+$ec_conf2 = array();
+$ec_conf2['dup_allow'] = read_ec_conf('dup_allow');
+$ec_conf2['duplic_display'] = read_ec_conf('duplic_display');
+$template->assign('ec_conf', $ec_conf2);
 
 ?>
Index: /extensions/event_cats/admin/evntcats_admin.php
===================================================================
--- /extensions/event_cats/admin/evntcats_admin.php	(revision 4328)
+++ /extensions/event_cats/admin/evntcats_admin.php	(revision 4329)
@@ -38,17 +38,6 @@
 if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
 
-global $template, $conf, $lang, $prefixeTable, $ec_conf, $page, $ec_debug,
- $ec_lists,   // array of following arrays :
-              //   $ec_lists['ec_table'] :
-              //     Event Cats table, in function of each entry id
-              //   $ec_lists['ec_codes'] : // Used ?
-              //     array of useful data, in function of entries codes
-              //   $ec_lists['add_pages'] :
-              //     array of Add. Pages names in function of their id
-              //   $ec_lists['categories'] :
-              //     array of category names in function of their id
-              //   $ec_lists['user_ids'] :
-              //     array of usernames in function of their id
- $ec_ap_ok;   // whether Additional Pages is installed and activated
+global $template, $conf, $lang, $prefixeTable,
+       $ec_conf, $page, $ec_debug, $ec_lists;
 
 load_language('plugin.lang', EVNTCATS_PATH);
@@ -88,5 +77,5 @@
 build_ec_lists(); // in evntcats_main_funcs.php
 
-// If no entry exist, default page is 'autolog_new'.
+// If no entry exist, default tab is 'autolog_new'.
 $page['tab'] = (!($ec_exist_entries = (mysql_num_rows(pwg_query("
   SELECT * FROM `".EVNTCATS_TABLE."`
@@ -94,55 +83,169 @@
 ")) != 0))) ? 'autolog_new' : 'autolog_entries';
 
-$ec_exist_duplic = ((mysql_num_rows(pwg_query("
-  SELECT * FROM `".EVNTCATS_TABLE."`
-  WHERE `code` IS NULL
-  AND `arg1` IS NOT NULL
-  AND `arg2` IS NOT NULL ;
-  ")) != 0) or
-  (read_ec_conf('duplic_gen') != 0) or
-  (read_ec_conf('duplic_type') != 0)
-);
-
-// If no entry exist, but some duplication management entries exist, default tab is 'duplication'.
-if (!$ec_exist_entries and $ec_exist_duplic) $page['tab'] = 'duplication';
-
-
-/* 
-
-if (isset($_POST[''])) {
-}
-
-
-if (isset($_POST['ec_duplic_conf_submit'])) {
-}
-
-if (isset($_POST['deny_groups_submit'])) {
-}
-
-if (isset($_POST['grant_groups_submit'])) {
-}
-
-if (isset($_POST['deny_types_submit'])) {
-}
-
-if (isset($_POST['grant_types_submit'])) {
-}
-
-if (isset($_POST['deny_users_submit'])) {
-}
-
-if (isset($_POST['grant_users_submit'])) {
-}
-
-
-
-
-*/
-
-
-
-
-
-if (isset($_POST['ec_act1'])) {
+// If no entry exist, but some duplication management entries exist, default
+// tab is 'duplication'.
+if (!$ec_exist_entries and read_ec_conf('dup_allow') == '2') $page['tab'] = 'duplication';
+
+// If a modification of duplication management has been posted, default tab
+// is 'duplication'.
+if (
+  count($_POST) > 0 and
+  count(array_intersect(array(
+    'ec_duplic_conf_submit',
+    'deny_groups_submit',
+    'grant_groups_submit',
+    'deny_types_submit',
+    'grant_types_submit',
+    'deny_users_submit',
+    'grant_users_submit',
+  ),
+  array_keys($_POST))) > 0
+) $page['tab'] = 'duplication';
+
+if (isset($_POST['ec_conf_submit'])) {
+  if (isset($_POST['ec_dup_conf']))
+   if (!change_ec_conf('dup_allow', $_POST['ec_dup_conf']))
+    ec_end2(7);
+  if (isset($_POST['ec_dup_disp']))
+   if (!change_ec_conf('duplic_display', $_POST['ec_dup_disp']))
+    ec_end2(8);
+  if (isset($_POST['ec_unknown']))
+   if (!change_ec_conf('unknown_code', $_POST['ec_unknown']))
+    ec_end2(9);
+  if (isset($_POST['ec_in_up_aps']))
+   if (!change_ec_conf('unknown_code_ap_id', $_POST['ec_in_up_aps']))
+    ec_end2(10);
+  $page['tab'] = 'config';
+  $page['infos'][] = l10n('ec_config_saved');
+}
+elseif (isset($_POST['ec_duplic_conf_submit'])) {
+  if (isset($_POST['ec_dup_conf'])) {
+    if (
+      read_ec_conf('dup_allow') == '2' and
+      $_POST['ec_dup_conf'] != '2'
+    ) $page['tab'] = 'config';
+    if (!change_ec_conf('dup_allow', $_POST['ec_dup_conf']))
+     ec_end2(5);
+  }
+  if (isset($_POST['ec_dup_disp']))
+   if (!change_ec_conf('duplic_display', $_POST['ec_dup_disp']))
+    ec_end2(6);
+  $page['infos'][] = l10n('ec_config_saved');
+}
+elseif (
+  isset($_POST['deny_groups_submit']) and
+  isset($_POST['deny_groups']) and
+  count($_POST['deny_groups']) > 0
+) {
+  if (pwg_query("
+    DELETE
+    FROM `".EVNTCATS_TABLE."`
+    WHERE `arg1` = 1
+      AND `arg2` IN (".implode(',', $_POST['deny_groups']).");
+  ") === false) ec_end2(1);
+  else $page['infos'][] = l10n('ec_config_saved');
+}
+elseif (
+  isset($_POST['grant_groups_submit']) and
+  isset($_POST['grant_groups']) and
+  count($_POST['grant_groups']) > 0
+) {
+  $inserts = array();
+  foreach ($_POST['grant_groups'] as $v) $inserts[] = array(
+    'arg1' => 1,
+    'arg2' => intval($v)
+  );
+  mass_inserts(EVNTCATS_TABLE, array('arg1', 'arg2'), $inserts);
+  $page['infos'][] = l10n('ec_config_saved');
+}
+elseif (
+  isset($_POST['deny_types_submit']) and (
+    isset($_POST['deny_types']) and
+    count($_POST['deny_types']) > 0 or
+    isset($_POST['deny_generic'])
+  )
+) {
+  $c = ($no_previous = (count($t = mysql_fetch_row(pwg_query("
+    SELECT `arg2`
+    FROM `".EVNTCATS_TABLE."`
+    WHERE `code` IS NULL
+      AND `arg1` = 3
+      AND `arg2` IS NOT NULL
+    LIMIT 1;
+  "))) == 0)) ? 0 : intval($t[0]);
+  if (isset($_POST['deny_types']))
+   foreach ($_POST['deny_types'] as $v) $c = $c & ~$v;
+  if (isset($_POST['deny_generic'])) $c = $c & 7;
+  $q = ($no_previous) ? "
+    INSERT INTO `".EVNTCATS_TABLE."`
+    (`arg1`, `arg2`)
+    VALUES (3, $c);
+  " : "
+    UPDATE `".EVNTCATS_TABLE."`
+    SET `arg2` = $c
+    WHERE `arg1` = 3
+    LIMIT 1 ;
+  ";
+  if (pwg_query($q) === false) ec_end2(3);
+  else $page['infos'][] = l10n('ec_config_saved');
+}
+elseif (
+  isset($_POST['grant_types_submit']) and (
+    isset($_POST['grant_types']) and
+    count($_POST['grant_types']) > 0 or
+    isset($_POST['grant_generic'])
+  )
+) {
+  $c = ($no_previous = (count($t = mysql_fetch_row(pwg_query("
+    SELECT `arg2`
+    FROM `".EVNTCATS_TABLE."`
+    WHERE `code` IS NULL
+      AND `arg1` = 3
+      AND `arg2` IS NOT NULL
+    LIMIT 1;
+  "))) == 0)) ? 0 : intval($t[0]);
+  if (isset($_POST['grant_types']))
+   foreach ($_POST['grant_types'] as $v) $c = $c | $v;
+  if (isset($_POST['grant_generic'])) $c = $c | 8;
+  $q = ($no_previous) ? "
+    INSERT INTO `".EVNTCATS_TABLE."`
+    (`arg1`, `arg2`)
+    VALUES (3, $c);
+  " : "
+    UPDATE `".EVNTCATS_TABLE."`
+    SET `arg2` = $c
+    WHERE `arg1` = 3
+    LIMIT 1 ;
+  ";
+  if (pwg_query($q) === false) ec_end2(4);
+  else $page['infos'][] = l10n('ec_config_saved');
+}
+elseif (
+  isset($_POST['deny_users_submit']) and
+  isset($_POST['deny_users']) and
+  count($_POST['deny_users']) > 0
+) {
+  if (pwg_query("
+    DELETE
+    FROM `".EVNTCATS_TABLE."`
+    WHERE `arg1` = 2
+      AND `arg2` IN (".implode(',', $_POST['deny_users']).");
+  ") === false) ec_end2(2);
+  else $page['infos'][] = l10n('ec_config_saved');
+}
+elseif (
+  isset($_POST['grant_users_submit']) and
+  isset($_POST['grant_users']) and
+  count($_POST['grant_users']) > 0
+) {
+  $inserts = array();
+  foreach ($_POST['grant_users'] as $v) $inserts[] = array(
+    'arg1' => 2,
+    'arg2' => intval($v)
+  );
+  mass_inserts(EVNTCATS_TABLE, array('arg1', 'arg2'), $inserts);
+  $page['infos'][] = l10n('ec_config_saved');
+}
+elseif (isset($_POST['ec_act1'])) {
   if (
     $_POST['ec_act1'] == 'disable' and
@@ -180,5 +283,5 @@
           build_ec_table();
         }
-        else ec_end1('ec_entry_sel', 'ec_bad_argument1');
+        else ec_end1('ec_entry_sel', 'Bad argument : ');
       }
       else if ($_POST['ec_act1'] == 'toggle_forced')
@@ -193,5 +296,5 @@
     break;
     case 'duplication':
-      if ($ec_exist_duplic) $page['tab'] = $_GET['tab'];
+      if (read_ec_conf('dup_allow') == '2') $page['tab'] = $_GET['tab'];
     break;
     case 'autolog_new':
@@ -211,13 +314,8 @@
 ")) != 0);
 
-$ec_exist_duplic = ((mysql_num_rows(pwg_query("
-  SELECT * FROM `".EVNTCATS_TABLE."`
-  WHERE `code` IS NULL
-  AND `arg1` IS NOT NULL
-  AND `arg2` IS NOT NULL ;
-  ")) != 0) or
-  (read_ec_conf('duplic_gen') != 0) or
-  (read_ec_conf('duplic_type') != 0)
-);
+if (
+  $page['tab'] == 'duplication' and
+  read_ec_conf('dup_allow') != '2'
+) $page['tab'] = 'config';
 
 $tabsheet = new tabsheet();
@@ -233,5 +331,5 @@
                l10n('ec_tab_autoid_new'),
                $my_base_url.'&amp;tab=autolog_new');
-if ($ec_exist_duplic) $tabsheet->add('duplication',
+if (read_ec_conf('dup_allow') == '2') $tabsheet->add('duplication',
                l10n('ec_tab_duplication'),
                $my_base_url.'&amp;tab=duplication');
Index: /extensions/event_cats/include/ec_conf.inc.php
===================================================================
--- /extensions/event_cats/include/ec_conf.inc.php	(revision 4328)
+++ /extensions/event_cats/include/ec_conf.inc.php	(revision 4329)
@@ -23,29 +23,48 @@
 // +-----------------------------------------------------------------------+
 
-global $ec_conf, $page, $ec_conf_index;
+global $ec_conf, $page, $ec_conf_index, $ec_conf_default,
+       $ec_conf_possible_values;
 
 // $ec_conf initalization
 
+// $ec_conf has numeric indexes (instead of string keys like 'activated',
+// 'howto'...) because of its first reading, done with the "explode" function.
+// It would be  very easy to build a string keys indexed array, thanks to
+// following instructions :
+/*
+$t = mysql_fetch_row(pwg_query("
+  SELECT `value`
+  FROM `".CONFIG_TABLE."`
+  WHERE `param` = 'event_cats';
+"));
+$ec_conf_temp = explode(',', $t[0]);
+$ec_conf = array(); $i = 0;
+foreach ($ec_conf_default as $k => $v) $ec_conf[$k] = ec_conf_temp[$i++];
+*/
+// Though, I prefer to keep $ec_conf with numeric indexes, so to be compelled
+// to go through function change_ec_conf() to modify ec_conf, and thus update
+// the DB at the same time.
+
 $ec_conf_default = array( // PLUGIN CONFIGURATION ($ec_conf) :
                           // ---------------------------------
-  'activated'             // plugin activated
+  'activated'             // plugin activated, 0 or 1
     => '0',               // 
                           // 
+  'howto'                 // whether the small aknowledgement message has
+    => '0',               // already been displayed, 0 or 1
+                          // 
   'dup_allow'             // duplication allowance :
-    => '0',               //   0 : no account ;
+    => '2',               //   0 : no account ;
                           //   1 : all accounts ;
                           //   2 : specified by group and user ids ;
                           // 
+  'duplic_display'        // duplication link display in the menubar :
+    => '2',               //   0 : "Register" for everybody ;
+                          //   1 : "Duplicate" for everybody ;
+                          //   2 : "Register" only for generic accounts,
+                          //       "Duplicate" for all other accounts ;
+                          // 
   'auto_code_dg_nb'       // number of digits when creating a new code
-    => '10',              // automatically
-                          // 
-  'duplic_gen'            // whether Generic accounts allow to be duplicated
-    => '0',               //
-                          // 
-  'duplic_type'           // the kind of account type (Contacts, Friends,
-    => '0',               // Family) allowed to duplicate account
-                          // 
-  'howto'                 // whether the small aknowledgement message has
-    => '0',               // already been displayed
+    => '10',              // automatically, several values
                           // 
   'unknown_code'          // what to do in case an unknown code is used with
@@ -57,5 +76,16 @@
                           // 
   'unknown_code_ap_id'    // the id of the Additional Page which must be used
-    => '0',               // in case of usage of an unknow code.
+    => '0',               // in case of usage of an unknow code, several vals.
+);
+
+$ec_conf_possible_values = array(
+  'activated'          => array('0', '1'),
+  'howto'              => array('0', '1'),
+  'dup_allow'          => array('0', '1', '2'),
+  'duplic_display'     => array('0', '1', '2'),
+  'auto_code_dg_nb'    => array( '4',  '5',  '8', '10', '12', '15',
+                                '16', '20', '24', '25', '30', '32'),
+  'unknown_code'       => array('0', '1', '2'),
+  'unknown_code_ap_id' => array()
 );
 
@@ -101,15 +131,24 @@
  */
 function change_ec_conf($c, $v) {
-  global $ec_conf, $page, $ec_conf_index;
+  global $ec_conf, $page, $ec_conf_index, $ec_conf_possible_values;
   if (array_key_exists($c, $ec_conf_index)) {
-    $ec_conf[$ec_conf_index[$c]] = $v;
-    return (pwg_query("
-      UPDATE `".CONFIG_TABLE."`
-      SET `value` = \"".implode(',', $ec_conf)."\"
-      WHERE `param` = 'event_cats';
-    ") !== false);
+    if (
+      count($ec_conf_possible_values[$c]) == 0 or
+      in_array($v, $ec_conf_possible_values[$c])
+    ) {
+      $ec_conf[$ec_conf_index[$c]] = $v;
+      return (pwg_query("
+        UPDATE `".CONFIG_TABLE."`
+        SET `value` = \"".implode(',', $ec_conf)."\"
+        WHERE `param` = 'event_cats';
+      ") !== false);
+    }
+    else {
+      $page['errors'][] = 'Bad change_ec_conf value';
+      return false;
+    }
   }
   else {
-    $page['errors'][] = 'Bad change_ec_conf argument';
+    $page['errors'][] = 'Bad change_ec_conf index';
     return false;
   }
@@ -130,5 +169,5 @@
    return $ec_conf[$ec_conf_index[$c]];
   else {
-    $page['errors'][] = 'Bad read_ec_conf argument';
+    $page['errors'][] = 'Bad read_ec_conf index';
     return false;
   }
